﻿// Keep this lines for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Controls\System\TcHmiControl\Source.d.ts" />

// Keep this lines for a best effort IntelliSense of Visual Studio 2013/2015.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery\jquery.js" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.js" />

(function (TcHmi) {

    var FunctionJS_ControlManipulation = function () {
        var Angle = 0;
        var timer = 0;
        var timer_is_on = 0;
        var h;
        var someControl = TcHmi.Controls.get('ViewDesktopBeckhoffLogo');
        startCount();

        function timedCount() {
            Angle = Angle + 2;
            timer = setTimeout(timedCount, 10);
            if (Angle > 360) {
                Angle = 0;
            }

            TcHmi.Symbol.readEx2('%s%PLC1.MAIN.startRotation%/s%', function (data) {
                if (data.error === TcHmi.Errors.NONE) {
                    var value = data.value;
                    if (value == false) {
                        Angle = 0;
                        h = [{
                            "transformType": "Origin",
                            "x": 100,
                            "xUnit": "px",
                            "y": 25,
                            "yUnit": "px",
                            "z": 0,
                            "zUnit": "px",
                        }, {
                            "transformType": "Rotate",
                            "angle": Angle,
                            "angleUnit": "deg"
                        }
                        ];
                        someControl.setTransform(h);
                        stopCount();
                    }
                } else {
                    console.log("Error reading variable startTimer");
                    stopCount();
                }
            });

            h = [{
                "transformType": "Origin",
                "x": 100,
                "xUnit": "px",
                "y": 25,
                "yUnit": "px",
                "z": 0,
                "zUnit": "px",
            }, {
                "transformType": "Rotate",
                "angle": Angle,
                "angleUnit": "deg"
            }
            ];
            someControl.setTransform(h);
        }

        function startCount() {
            if (!timer_is_on) {
                timer_is_on = 1;
                timedCount();
            }
        }

        function stopCount() {
            clearTimeout(timer);
            timer_is_on = 0;
        }
    };
    TcHmi.Functions.registerFunction('FunctionJS_ControlManipulation', FunctionJS_ControlManipulation);
})(TcHmi);